/*
 * Copyright 2024 Dominic Grimm
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.dergrimm.keycloak.providers.events.mqtt

import org.keycloak.events.EventType
import org.keycloak.events.admin.OperationType
import akka.stream.scaladsl.Sink
import akka.stream.alpakka.mqtt.MqttMessage
import akka.Done
import scala.concurrent.Future

final case class MqttEventListenerProviderFactoryData(
    excludedEvents: Option[Set[EventType]],
    excludedAdminOperations: Option[Set[OperationType]],
    mqttOptions: MqttOptions,
    mqttSink: Sink[MqttMessage, Future[Done]]
)
